Codeforces Round 938 (Div. 3) (A~E)

2024-04-09 14:12
文章标签 codeforces round div 938

本文主要是介绍Codeforces Round 938 (Div. 3) (A~E),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Codeforces Round 938 (Div. 3) (A~E)

目录:A B C D E

A题:Yogurt Sale

标签: 数学(math)

题目大意

  • 酸奶价格, a 元一份,b元两份n
  • 问:买n份最少多少钱

思路

  • a元一份,b元两份,总有一个比较低,一份一份买或两份两份买取小的一个即可,特判n为奇数多买一个a

AC代码

#include <bits/stdc++.h>
using namespace std;
void solve()
{int n, a, b;cin >> n >> a >> b;cout << min(n * a, n / 2 * b + n % 2 * a) << endl;
}
int main()
{int T; cin >> T;while(T--)solve();return 0; 
}

B题:Progressive Square

标签: 构造算法(constructive algorithms)数据结构(data structures)实现问题,编程技巧,模拟(implementation)排序算法(sortings)

题目大意

  • 一个 n × n阵。三个整数 a1,1 、 c 和 d 并按照以下规则构造一个累进正方形:
  • ai+1,j = ai,j + c
  • ai,j+1 = ai,j + d
  • 即:每一行每一列都是等差数列,公差分别为c,d
  • 问题:给n,c,d 和一个长n × n的数组,问此数组是否是个累进正方形

思路

  • 找到数组中最小值一定被作为a1,1,知道a1,1,c,d直接将累进正方形计算出 与 给定数组比较即可

AC代码

#include <bits/stdc++.h>
using namespace std;
const int N = 250010;
int a[N], b[N];
void solve()
{int n, c, d;int idx = 0;cin >> n >> c >> d;for(int i = 0; i < n * n; i++)cin >> a[i];sort(a, a + n * n);int t = a[0];for(int i = 0; i < n; i++)for(int j = 0; j < n; j++)b[idx++] = t + i * c + j * d; sort(b, b + n * n);for(int i = 0; i < n * n; i++)if(a[i] != b[i]) {cout << "NO" << endl;return;}cout << "YES" << endl;
}
int main()
{int T; cin >> T;while(T--)solve();return 0; 
}

C题:Inhabitant of the Deep Sea

标签: 贪心策略(greedy)实现问题,编程技巧,模拟(implementation)数学(math)

题目大意

  • n 艘飞船编号从 1 到 n ,依次递增;第 i 艘飞船的耐久度为 ai
  • 攻击次数:k 次
  • 攻击力: 1
  • 攻击顺序:攻击第一艘飞船,然后是最后一艘,接着又是第一艘,以此类推。
  • 当船只的耐久度下降到 0时,它就会沉没,不再受到攻击
  • :攻击k次后沉没几艘飞船

思路

  • 分两种情况
  • 1、攻击次数大于等于耐久度和,那么全部飞船都会沉没
  • 2、攻击次数小于耐久度和,那么左边飞船共被攻击(k / 2 + k % 2)次,右侧飞船共被攻击k / 2次
  • 枚举计算攻击次数能击沉左边多少艘,右边多少艘即可

AC代码

#include <bits/stdc++.h>
#define LL long long
using namespace std;
const int N = 200010;
int a[N];
void solve()
{LL n, k, cnt = 0;cin >> n >> k;for(int i = 1; i <= n; i++){cin >> a[i];cnt += a[i];}if(k >= cnt){cout << n << endl;return;}LL t1 = k / 2 + k % 2; // 左侧先被攻击,所以k为奇数时左侧比右侧多1次LL t2 = k / 2;int l = 1, r = n;while(l <= n && t1 >= a[l])t1 -= a[l++];while(r >= 1 && t2 >= a[r])t2 -= a[r --];// 左侧被击沉l - 1艘,右侧被击沉n - r艘cout << l - 1 + n - r << endl;
}
int main()
{int T; cin >> T;while(T--)solve();return 0; 
}

D题:Inaccurate Subsequence Search

标签: 数据结构(data structures)双指针算法(two pointers)

题目大意

  • 有一个由 n 个整数组成的数组 a 和一个由 m 个整数组成的数组 b ( m ≤ n )。
  • 好数组定义:如果数组 c 中的元素可以重新排列,使得其中至少有 k 个元素与数组 b 中的元素匹配,那么认为长度为 m 的数组 c 是好数组。
  • :选择长度为 m 的数组 a 的每个子段作为数组 c 的元素,计算有多少个数组是好的
  • 换句话说,求元素 al,al+1,…,al+m−1构成一个好数组的位置1 ≤ l ≤ n − m + 1 的个数。

思路

  • 滑动窗口暴力模拟即可,具体看代码(含注释)

AC代码

#include <bits/stdc++.h>
#define LL long long
using namespace std;
const int N = 200010;
int a[N], b[N];
void solve()
{int n, m, k;cin >> n >> m >> k;for(int i = 1; i <= n; i++)cin >> a[i];//mp1记录b中数与其数量,mp2记录每个长为m的a的子数组中数(动态维护) map<int, int> mp1, mp2; for(int i = 1; i <= m; i++) {cin >> b[i];mp1[b[i]] ++;  }// cnt维护每个长为m的窗口与b匹配数的个数,res记录答案 int cnt = 0, res = 0;for(int i = 1; i <= n; i++){// i <= m时只添加数,添加a[i]到mp2 if(i <= m){// 添加a[i]到mp2 // 如过添加的数在b中还未匹配的数中存在,匹配数+1 if(mp2[a[i]] < mp1[a[i]]) cnt ++;mp2[a[i]] ++;   }else {if(cnt >= k) res ++;  // 如果当前子数组匹配数大于k,答案+1 // 上同 if(mp2[a[i]] < mp1[a[i]]) cnt ++;mp2[a[i]] ++; // 重点:如果当前子数组中a[i-m]的数量小于等于b中的数量,那么删除a[i-m]才会影响匹配数 if(mp2[a[i-m]] <= mp1[a[i-m]]) cnt --;mp2[a[i - m]] --;}}// 最后一次变化后没判断 if(cnt >= k) res ++;cout << res << endl;
}
int main()
{int T; cin >> T;while(T--)solve();return 0; 
}

E题:Long Inversions

标签: 暴力枚举(brute force)贪心策略(greedy)实现问题,编程技巧,模拟(implementation)排序算法(sortings)

题目大意

  • 给出长度为 n 的仅由字符 "1 "和 "0 "组成的字符串 s。
  • 选择一个整数 k ( 1 ≤ k ≤ n),然后任意多次执行以下操作:
    • 选择字符串中连续的 k 个字符并将其反转,即用 "1 "替换所有 “0”,反之亦然。
  • 通过这些操作,您需要使字符串中的所有字符都等于 “1”。
  • 求:k 的最大值

思路

  • 两步一起可交换或反转每相隔为k + 1位置的数字
  • 例如k = 3如图1,反转红线和黑线,即交换和反转相隔为k + 1位置的数字
  • 那么如图2中的相连的数字都可以任意交换位置
  • 一种做法:用以上方法将0全部移到前1 ~ k 个字符上,然后将其反转,判断能否全部反转即可

AC代码

#include <bits/stdc++.h>
using namespace std;
const int N = 200010;
int a[N], b[N], n;
string s;
bool check(int x)
{int res = 0;for(int i = 0; i < x; i++){int cnt = 0;for(int j = i; j < n; j += x)if(s[j] == '0') cnt ++;res += cnt % 2;}return res % x;
}
void solve()
{cin >> n >> s;int k = n;while(check(k)) k--;cout << k << endl;
}
int main()
{int T; cin >> T;while(T--)solve();return 0; 
}

logo

//へ     /|
//  /\7    ∠_/
//  / │   / /
// │ Z _,< /   /`ヽ
// │     ヽ   /  〉
//  Y     `  /  /
// イ● 、 ●  ⊂⊃〈  /
// ()  へ    | \〈
//  >ー 、_  ィ  │ //
//  / へ   / ノ<| \\
//  ヽ_ノ  (_/  │//
//	  7       |/
//
/*__   _,--="=--,_   __/  \."    .-.    "./  \/  ,/  _   : :   _  \/` \\  `| /o\  :_:  /o\ |\__/`-'| :="~` _ `~"=: |\`     (_)     `/.-"-.   \      |      /   .-"-.
.---{     }--|  /,.-'-.,\  |--{     }---.)  (_)_)_)  \_/`~-===-~`\_/  (_(_(_)  (
(                         				))                                     (
'---------------------------------------'
*/

这篇关于Codeforces Round 938 (Div. 3) (A~E)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/888363

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There